﻿using System;
using Telerik.UI.Xaml.Controls.Grid;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Data;

namespace RadDataGrid_444
{
    public class FocusableNumericColumn : DataGridNumericalColumn
    {
        private static Type NumericBoxType = typeof(NumericColumnEditPicker);
        private static Type TextBlockType = typeof(TextBlock);

        public override object GetEditorType(object item)
        {
            return this.CanUserEdit ? NumericBoxType : TextBlockType;
        }

        public override FrameworkElement CreateEditorContentVisual()
        {
            return new NumericColumnEditPicker();
        }

        public override void PrepareEditorContentVisual(FrameworkElement editorContent, Binding binding)
        {
            editorContent.SetBinding(NumericColumnEditPicker.ValueProperty, binding);
        }

        public override void ClearEditorContentVisual(FrameworkElement editorContent)
        {
            ((NumericColumnEditPicker)editorContent).hasInitialFocus = false;
            editorContent.ClearValue(NumericColumnEditPicker.ValueProperty);
        }
    }
}
