﻿using System;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Threading.Tasks;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Input;

// The Blank Page item template is documented at https://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace RadDataGrid_444
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        private readonly ObservableCollection<Item> _items;
        private static double DataGridPaddingOffset = 14;
        public MainPage()
        {
            InitializeComponent();

           // this.dataGrid.ItemsSource = _items = new ObservableCollection<Item>();

            this.dataGrid.ItemsSource = _items = new ObservableCollection<Item>
            {
                new Item { Barcode = "234", Quantity = 25, Price = 3000, Name = "Item 2" },
                new Item { Barcode = "352", Quantity = 4, Price = 2500, Name = "Item 1" },
                new Item { Barcode = "642", Quantity = 7, Price = 6000, Name = "Item 1" },
            };
        }

        private readonly Random _random = new Random();
        private async void barcodeTextBox_KeyUp(object sender, KeyRoutedEventArgs e)
        {
            if (e.Key == Windows.System.VirtualKey.Enter)
            {
                var item = new Item
                {
                    Barcode = barcodeTextBox.Text,
                    Name = $"Item ({barcodeTextBox.Text})",
                    Price = _random.Next(1000, 25000),
                    Quantity = _random.Next(1, 200),
                };

                _items.Add(item);
                await Task.Delay(100);

                dataGrid.SelectCell(new Telerik.UI.Xaml.Controls.Grid.DataGridCellInfo(item, quantityColumn));
                dataGrid.BeginEdit(item);
            }
        }
    }

    public class Item : INotifyPropertyChanged
    {
        public string Barcode { get; set; }
        public string Name { get; set; }

        public double TotalPrice => Quantity * Price;

        private double _quantity;
        public double Quantity
        {
            get { return _quantity; }
            set
            {
                _quantity = value;
                OnPropertyChanged(nameof(TotalPrice));
            }
        }

        private double _price;
        public double Price
        {
            get { return _price; }
            set
            {
                _price = value;
                OnPropertyChanged(nameof(TotalPrice));
            }
        }

        private void OnPropertyChanged(string propertyName)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}
