﻿using Telerik.UI.Xaml.Controls;
using Telerik.UI.Xaml.Controls.Input;
using Windows.ApplicationModel;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

namespace RadDataGrid_444
{
    public class NumericColumnEditPicker : RadNumericBox
    {
        internal bool hasInitialFocus;
        private TextBox textBox;

        protected override bool ApplyTemplateCore()
        {
            var applied = base.ApplyTemplateCore();

            this.textBox = this.GetTemplatePartField<TextBox>("PART_TextBox");
            applied = applied && this.textBox != null;

            return applied;
        }

        internal T GetTemplatePartField<T>(string name) where T : DependencyObject
        {
            T part = this.GetTemplateChild(name) as T;
            if (part == null && !DesignMode.DesignModeEnabled)
            {
                throw new MissingTemplatePartException(name, typeof(T));
            }

            return part;
        }

        protected override void OnGotFocus(RoutedEventArgs e)
        {
            base.OnGotFocus(e);
            if (!this.hasInitialFocus)
            {
                this.textBox.Focus(FocusState.Programmatic);
                this.hasInitialFocus = true;
            }
        }
    }
}
